'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.checkForFaultyFields = exports.keywordsError = exports.faultyKeywords = undefined;

var _ramda = require('ramda');

const faultyKeywords = exports.faultyKeywords = [`length`];

// TODO: provide a link to aliasing section in plugin's README
const keywordsError = exports.keywordsError = `Found unaliased reserved field with a name matching one of ${faultyKeywords}. Build failed! Please refer to the caveats in the gatsby-source-graphcms README for a solution. (link)`;

// Checking if the query we pass in config has any of the faulty fields
const checkForFaultyFields = exports.checkForFaultyFields = (data, keywords) => {
  const getAllKeys = obj => {
    const all = [];
    const getKeys = obj => all.push(...Object.keys(obj).map(key => obj[key] instanceof Object ? getKeys(obj[key]) && key : key));
    getKeys(obj);
    return all;
  };

  const containsKeywords = (0, _ramda.intersection)(getAllKeys(data), keywords).length > 0;

  return containsKeywords;
};